<?php namespace Notes\Breadcrumb;

use Notes\ObjectReflection,
    Notes\ObjectResolver;

use RuntimeException, DirectoryIterator, Generator;

class Breadcrumb {

    protected array $folderList;

    protected array $fileList;

    public function __construct(array $folderList = []) {
        $this->folderList = $folderList;
    }

    public function addFolder($folder) : void
    {
        $this->folderList[] = $folder;
    }

    public function setFolderList(array $list) : void
    {
        $this->folderList = $list;
    }

    public function scan() : Generator
    {
        foreach($this->folderList as $namespace => $folder) {
            if ( ! file_exists($folder) ) {
                throw new RuntimeException(sprintf("Folder `%s` can not be found or scanned", $folder));
            }

            foreach (new DirectoryIterator($folder) as $fileinfo) {
                if ( ! $fileinfo->isDot() ) {
                    yield $namespace => $fileinfo;
                }
            }
        }
    }

    public function compile() : array
    {
        foreach($this->scan() as $namespace => $file) {
            $class = $this->generateClassname($file->getBasename(".php"), $namespace);

            # Should generate an equivalent of Ulmus's object reflection here !
            # var_dump( "<pre>", , "</pre>" );
            $objectResolver = new ObjectResolver($class);

            #if ( null === $class = $this->getAnnotationFromClassname( Table::class ) ) {

        #    }

        }

        return [];
    }

}
